
;#####################################################################################

;MihailTunes Animated Tray Icon Demo - DednDave, 1-2012

;#####################################################################################

        INCLUDE \Masm32\Include\masm32rt.inc

;#####################################################################################

;equates

TIMER_ELAPSE EQU 125        ;time between icon "frames", in mS

ICON_QTY     EQU 10

;*************************************************************************************

;control ID's

IDI_ICON0    EQU 50
IDI_ICON1    EQU 51
IDI_ICON2    EQU 52
IDI_ICON3    EQU 53
IDI_ICON4    EQU 54
IDI_ICON5    EQU 55
IDI_ICON6    EQU 56
IDI_ICON7    EQU 57
IDI_ICON8    EQU 58
IDI_ICON9    EQU 59

IDD_DEMODLG  EQU 80

IDT_TIMER0   EQU 90

;*************************************************************************************

IFNDEF       SC_DRAGMOVE
SC_DRAGMOVE  EQU 0F012h
ENDIF

;#####################################################################################

;        .DATA

;*************************************************************************************

        .DATA?

hInstance dd ?
uFrameCnt dd ?
hIcons    dd ICON_QTY dup(?)

nid       NOTIFYICONDATA <>

;#####################################################################################

        .CODE

;*************************************************************************************

DlgProc PROC    hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

        mov     eax,uMsg
        cmp     eax,WM_TIMER
        jz      WmTimer

        cmp     eax,WM_LBUTTONDOWN
        jz      WmLButtonDown

        cmp     eax,WM_COMMAND
        jz      WmCommand

        cmp     eax,WM_INITDIALOG
        jz      WmInitDialog

        cmp     eax,WM_CLOSE
        jz      WmClose

UnProcessed:
        xor     eax,eax

DlgExit:
        ret

WmTimer:
        push    ebx
        mov     eax,uFrameCnt
        xor     edx,edx
        inc     eax
        mov     ebx,offset hIcons
        cmp     eax,25
        jb      WmTimer1

        xor     eax,eax

WmTimer1:
        mov     ecx,5
        mov     uFrameCnt,eax
        cmp     eax,15
        jb      WmTimer2

        sub     eax,15
        add     ebx,4*5

WmTimer2:
        div     ecx
        shl     edx,2
        mov     eax,[ebx+edx]
        mov     nid.hIcon,eax
        INVOKE  SendMessage,hWnd,WM_SETICON,ICON_BIG,eax
        INVOKE  Shell_NotifyIcon,NIM_MODIFY,offset nid
        pop     ebx

Processed:
        mov     eax,1
        jmp     DlgExit

WmLButtonDown:
        INVOKE  ReleaseCapture
        INVOKE  SendMessage,hWnd,WM_SYSCOMMAND,SC_DRAGMOVE,0
        jmp     Processed

WmInitDialog:
        push    esi
        push    ebx
        push    edi
        mov     esi,offset nid
        mov     eax,hIcons
        mov     ebx,hWnd
        xor     edi,edi
        mov     [esi].NOTIFYICONDATA.hIcon,eax
        INVOKE  SendMessage,ebx,WM_SETICON,ICON_BIG,eax
        mov     [esi].NOTIFYICONDATA.cbSize,sizeof NOTIFYICONDATA
        mov     [esi].NOTIFYICONDATA.hwnd,ebx
        mov     [esi].NOTIFYICONDATA.uID,IDT_TIMER0
        mov     [esi].NOTIFYICONDATA.uFlags,NIF_ICON
        mov     [esi].NOTIFYICONDATA.uCallbackMessage,edi
        INVOKE  Shell_NotifyIcon,NIM_ADD,esi
        INVOKE  SetTimer,ebx,IDT_TIMER0,TIMER_ELAPSE,edi
        pop     edi
        pop     ebx
        pop     esi
        jmp     Processed

WmCommand:
        cmp     wParam,BN_CLICKED SHL 16 OR IDCANCEL
        jnz     Processed

WmClose:
        INVOKE  KillTimer,hWnd,IDT_TIMER0
        INVOKE  Shell_NotifyIcon,NIM_DELETE,offset nid
        INVOKE  EndDialog,hWnd,0
        jmp     Processed

DlgProc ENDP

;*************************************************************************************

_main   PROC

;---------------------------------------------

;initialize common controls and hInstance

        xor     edi,edi
        push    edi
        push    sizeof INITCOMMONCONTROLSEX
        INVOKE  InitCommonControlsEx,esp
        INVOKE  GetModuleHandle,edi
        mov     hInstance,eax

;---------------------------------------------

;fill the icon handle array

        mov     esi,IDI_ICON9
        mov     ebx,4*(ICON_QTY-1)

LdIcon: INVOKE  LoadIcon,hInstance,esi
        mov     hIcons[ebx],eax
        dec     esi
        sub     ebx,4
        jnc     LdIcon

;---------------------------------------------

;create the dialog box

        INVOKE  DialogBoxParam,hInstance,IDD_DEMODLG,edi,DlgProc,edi

;---------------------------------------------

;terminate

        INVOKE  ExitProcess,edi

_main   ENDP

;#####################################################################################

        END     _main

